<template>
     <b-container>
        <h1>Ghigliottina</h1>
        <div class="container-data">
            <b-form-datepicker placeholder="Seleziona una data" id="start-datepicker" v-model="start_date" :max="now"></b-form-datepicker>
            <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" type="submit" @click="search()">Cerca</b-button>
        </div> 
        <div class="container-tabs">
            <b-tabs content-class="mt-3" align="center">
                <b-tab title="Parole" @click="clickedTab('parole')" >
                    <div v-if="showWords" class="container-tweet">
                        <Tweet :id="message" :key="message" ><SpinnerComponent></SpinnerComponent></Tweet>
                    </div>
                </b-tab>
                <b-tab title="Classifica" @click="clickedTab('classifica')">
                    <div v-if="showData" class="container-tweet">
                        <Tweet :id="message" :key="message" ><SpinnerComponent></SpinnerComponent></Tweet>
                    </div>
                    <b-container style="padding-top: 20px;" v-if="top && top.length >0" >
                        <b-table
                            id="table"
                            bordered
                            striped
                            hover
                            fixed
                            :items="top"
                            :fields="fields"
                        ></b-table>
                    </b-container>
                </b-tab>
            </b-tabs>
        </div>
    </b-container>
</template>

<script>
import axios from 'axios'
import { Tweet } from 'vue-tweet-embed'
import SpinnerComponent from '../components/SpinnerComponent.vue'

export default {
    components: {
        Tweet,
        SpinnerComponent
    },
    name: "GhigliottinaView",
    data () {
        return {
            message: '1601239833053396992',
            init: true,
            top: [],
            res: '',
            start_date: '',
            showData: false,
            showRanking: false,
            showWords: true,
            notyet: false,
            now: new Date(),
            fields: [
                {key: "position", label: "Position", sortable: true},
                {key: "username", label: "User", sortable: false},
            ]
        }
    },
    methods: {
        clickedTab(type) {
            if (type == 'classifica') { this.showRanking = true }
            else if (type == 'parola') { this.showWords = true }
        },
        search: async function() {
            this.showData = false;
            this.top = []
            let today = new Date()
            let dd = String(today.getDate()).padStart(2, '0')
            let mm = String(today.getMonth() + 1).padStart(2,'0')
            let yyyy = today.getFullYear()
            let hour = today.getHours()
            let display
            today = yyyy + '-' + mm + '-' + dd
            if(this.start_date == today){
                if(hour < 20){
                    this.message = '1603345384935653377'
                    this.showData = true
                }
                else{
                display = await axios.get("http://localhost:8000/api/v1/getword/"+today)
                .catch(() => {
                        this.message = '1595053740725538817'
                        this.showData = true
                    })
                this.message = this.display[0]
                setTimeout(async() => {
                this.res = await axios.get("http://localhost:8000/api/v1/getfinalrank/"+today+"/"+display.data[1]+"/"+display.data[2])
                .catch(() => {
                    this.message = '1595053740725538817'
                    this.showData = true
                })
                }, 3000)
                }
            }
            else{
                display = await axios.get("http://localhost:8000/api/v1/getword/"+this.start_date)
                .catch(() => {
                        this.message = '1595053740725538817'
                        this.showData = true
                    })
                this.message = display.data[0]
                setTimeout(async() => {
                    this.res = await axios.get("http://localhost:8000/api/v1/getfinalrank/"+this.start_date+"/"+display.data[1]+"/"+display.data[2])  
                    .catch(() => {
                        this.message = '1595053740725538817'
                        this.showData = true
                    })
                    for(let i=0; i<this.res?.data?.length; i++) {
                        this.top.push({ username: this.res.data[i], position: i+1})
                     }
                }, 3000)
            }
           
        }
    }
}
</script>

<style scoped>
::v-deep .container-tweet .twitter-tweet.twitter-tweet-rendered {
  margin: 2rem auto!important;
}
.container-data {
  display: flex;
  align-items: center;
  justify-content: space-evenly;
  margin-top: 2rem;
}
.container-data button {
    margin-left: 1rem;
}
.box {
    margin: 2rem auto;
}
.container-tabs {
  margin: 2rem auto;
}
.container {
    margin: 2rem auto;
}
.b-form-btn-label-control.form-control {
    text-align: left;
}

</style>